Logic {base} | R Documentation

## Logical Operators

### Description

These operators act on logical vectors.

### Usage

    ! x
    x & y
    x && y
    x | y
    x || y
    xor(x, y)

### Arguments

`x, y` | logical vectors

### Details

`!` indicates logical negation (NOT).

`&` and `&&` indicate logical AND and `|` and `||` indicate logical OR. The shorter form performs elementwise comparisons in much the same way as arithmetic operators. The longer form evaluates left to right examining only the first element of each vector. Evaluation proceeds only until the result is determined. The longer form is appropriate for programming control-flow and typically preferred in `if` clauses.

`xor` indicates elementwise exclusive OR.

`NA` is a valid logical object. Where a component of `x` or `y` is `NA`, the result will be `NA` if the outcome is ambiguous. In other words `NA & TRUE` evaluates to `NA`, but `NA & FALSE` evaluates to `FALSE`. See the examples below.

### References

Becker, R. A., Chambers, J. M. and Wilks, A. R. (1988) The New S Language. Wadsworth & Brooks/Cole.

### See Also

`TRUE` or `logical`.

`Syntax` for operator precedence.

### Examples

    y <- 1 + (x <- rpois(50, lambda=1.5) / 4 - 1)
    x[(x > 0) & (x < 1)]    # all x values between 0 and 1
    if (any(x == 0) || any(y == 0)) "zero encountered"

    ## construct truth tables :

    x <- c(NA, FALSE, TRUE)
    names(x) <- as.character(x)
    outer(x, x, "&")## AND table
    outer(x, x, "|")## OR  table

[Package Contents]